Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| IAIK PKCS#11 Wrapper version 1.2.18
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## iaik.pkcs.pkcs11.objects
Class DSAPrivateKey

    java.lang.Object
      |
      +--iaik.pkcs.pkcs11.objects.Object
            |
            +--iaik.pkcs.pkcs11.objects.Storage
                  |
                  +--iaik.pkcs.pkcs11.objects.Key
                        |
                        +--iaik.pkcs.pkcs11.objects.PrivateKey
                              |
                              +--iaik.pkcs.pkcs11.objects.DSAPrivateKey

All Implemented Interfaces:
  java.lang.Cloneable

public class DSAPrivateKey
extends PrivateKey

Objects of this class represent DSA private keys as specified by PKCS#11 v2.11.

Version:
  1.0
Author:
  Karl Scheibelhofer

Inner classes inherited from class iaik.pkcs.pkcs11.objects.Key
`Key.KeyType, Key.VendorDefinedKeyBuilder`

Inner classes inherited from class iaik.pkcs.pkcs11.objects.Object
`Object.ObjectClass, Object.VendorDefinedObjectBuilder`

Field Summary
`protected ByteArrayAttribute` | `base_` The base (g) of this DSA key.
`protected ByteArrayAttribute` | `prime_` The prime (p) of this DSA key.
`protected ByteArrayAttribute` | `subprime_` The subprime (q) of this DSA key.
`protected ByteArrayAttribute` | `value_` The private value (x) of this DSA key.

Fields inherited from class iaik.pkcs.pkcs11.objects.PrivateKey
`alwaysAuthenticate_, alwaysSensitive_, authPinFlags_, decrypt_, extractable_, neverExtractable_, secondaryAuth_, sensitive_, sign_, signRecover_, subject_, unwrap_, unwrapTemplate_, wrapWithTrusted_`

Fields inherited from class iaik.pkcs.pkcs11.objects.Key
`allowedMechanisms_, derive_, endDate_, id_, keyGenMechanism_, keyType_, keyTypeNames_, local_, startDate_, vendorKeyBuilder_`

Fields inherited from class iaik.pkcs.pkcs11.objects.Storage
`label_, modifiable_, private_, token_`

Fields inherited from class iaik.pkcs.pkcs11.objects.Object
`attributeTable_, objectClass_, objectClassNames_, objectHandle_, vendorObjectBuilder_`

Constructor Summary
`` | `DSAPrivateKey()` Deafult Constructor.
`protected` | `DSAPrivateKey(Session session, long objectHandle)` Called by getInstance to create an instance of a PKCS#11 DSA private key.

Method Summary
`protected void` | `allocateAttributes()` Allocates the attribute objects for this class and adds them to the attribute table.
`java.lang.Object` | `clone()` Create a (deep) clone of this object.
`boolean` | `equals(java.lang.Object otherObject)` Compares all member variables of this object with the other object.
`ByteArrayAttribute` | `getBase()` Gets the base attribute of this DSA key.
`static Object` | `getInstance(Session session, long objectHandle)` The getInstance method of the PrivateKey class uses this method to create an instance of a PKCS#11 DSA private key.
`ByteArrayAttribute` | `getPrime()` Gets the prime attribute of this DSA key.
`ByteArrayAttribute` | `getSubprime()` Gets the subprime attribute of this DSA key.
`ByteArrayAttribute` | `getValue()` Gets the value attribute of this DSA key.
`protected static void` | `putAttributesInTable(DSAPrivateKey object)` Put all attributes of the given object into the attributes table of this object.
`void` | `readAttributes(Session session)` Read the values of the attributes of this object from the token.
`java.lang.String` | `toString()` This method returns a string representation of the current object.

Methods inherited from class iaik.pkcs.pkcs11.objects.PrivateKey
`getAlwaysAuthenticate, getAlwaysSensitive, getAuthPinFlags, getDecrypt, getExtractable, getNeverExtractable, getSecondaryAuth, getSensitive, getSign, getSignRecover, getSubject, getUnknownPrivateKey, getUnwrap, getUnwrapTemplate, getWrapWithTrusted, putAttributesInTable`

Methods inherited from class iaik.pkcs.pkcs11.objects.Key
`getAllowedMechanisms, getDerive, getEndDate, getId, getKeyGenMechanism, getKeyType, getKeyTypeName, getLocal, getStartDate, getVendorDefinedKeyBuilder, hashCode, putAttributesInTable, setVendorDefinedKeyBuilder`

Methods inherited from class iaik.pkcs.pkcs11.objects.Storage
`getLabel, getModifiable, getPrivate, getToken, putAttributesInTable`

Methods inherited from class iaik.pkcs.pkcs11.objects.Object
`getAttributeTable, getAttributeValue, getAttributeValues, getObjectClass, getObjectClassName, getObjectHandle, getSetAttributes, getSetAttributes, getUnknownObject, getVendorDefinedObjectBuilder, putAttributesInTable, setObjectHandle, setVendorDefinedObjectBuilder`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### prime_

    protected ByteArrayAttribute prime_

  The prime (p) of this DSA key.

### subprime_

    protected ByteArrayAttribute subprime_

  The subprime (q) of this DSA key.

### base_

    protected ByteArrayAttribute base_

  The base (g) of this DSA key.

### value_

    protected ByteArrayAttribute value_

  The private value (x) of this DSA key.

Constructor Detail

### DSAPrivateKey

    public DSAPrivateKey()

  Deafult Constructor.

### DSAPrivateKey

    protected DSAPrivateKey(Session session,
                            long objectHandle)
                     throws TokenException

  Called by getInstance to create an instance of a PKCS#11 DSA private key.
  Parameters:
    `session` - The session to use for reading attributes. This session must have the appropriate rights; i.e. it must be a user-session, if it is a private object.
    `objectHandle` - The object handle as given from the PKCS#111 module.
  Throws:
    `TokenException` - If getting the attributes failed.

Method Detail

### getInstance

    public static Object getInstance(Session session,
                                     long objectHandle)
                              throws TokenException

  The getInstance method of the PrivateKey class uses this method to create an instance of a PKCS#11 DSA private key.
  Parameters:
    `session` - The session to use for reading attributes. This session must have the appropriate rights; i.e. it must be a user-session, if it is a private object.
    `objectHandle` - The object handle as given from the PKCS#111 module.
  Returns:
    The object representing the PKCS#11 object. The returned object can be casted to the according sub-class.
  Throws:
    `TokenException` - If getting the attributes failed.

### putAttributesInTable

    protected static void putAttributesInTable(DSAPrivateKey object)

  Put all attributes of the given object into the attributes table of this object. This method is only static to be able to access invoke the implementation of this method for each class separately (see use in clone()).
  Parameters:
    `object` - The object to handle.

### allocateAttributes

    protected void allocateAttributes()

  Allocates the attribute objects for this class and adds them to the attribute table.
  Overrides:
    `allocateAttributes` in class `PrivateKey`

### clone

    public java.lang.Object clone()

  Create a (deep) clone of this object.
  Overrides:
    `clone` in class `PrivateKey`
  Returns:
    A clone of this object.

### equals

    public boolean equals(java.lang.Object otherObject)

  Compares all member variables of this object with the other object. Returns only true, if all are equal in both objects.
  Overrides:
    `equals` in class `PrivateKey`
  Parameters:
    `otherObject` - The other object to compare to.
  Returns:
    True, if other is an instance of this class and all member variables of both objects are equal. False, otherwise.

### getPrime

    public ByteArrayAttribute getPrime()

  Gets the prime attribute of this DSA key.
  Returns:
    The prime attribute.

### getSubprime

    public ByteArrayAttribute getSubprime()

  Gets the subprime attribute of this DSA key.
  Returns:
    The subprime attribute.

### getBase

    public ByteArrayAttribute getBase()

  Gets the base attribute of this DSA key.
  Returns:
    The base attribute.

### getValue

    public ByteArrayAttribute getValue()

  Gets the value attribute of this DSA key.
  Returns:
    The value attribute.

### readAttributes

    public void readAttributes(Session session)
                        throws TokenException

  Read the values of the attributes of this object from the token.
  Overrides:
    `readAttributes` in class `PrivateKey`
  Parameters:
    `session` - The session handle to use for reading attributes. This session must have the appropriate rights; i.e. it must be a user-session, if it is a private object.
  Throws:
    `TokenException` - If getting the attributes failed.

### toString

    public java.lang.String toString()

  This method returns a string representation of the current object. The output is only for debugging purposes and should not be used for other purposes.
  Overrides:
    `toString` in class `PrivateKey`
  Returns:
    A string presentation of this object for debugging output.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| IAIK PKCS#11 Wrapper version 1.2.18
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

IAIK JavaSecurity Website http://jce.iaik.tugraz.at/
IAIK at Graz University of Technology, Austria, Europe
Copyright 2001-2004, IAIK, Graz University of Technology, Inffeldgasse 16a, 8010 Graz, Austria. All Rights Reserved. version 1.2.18